module Bitcointerminal
  module Configurable
    def self.included(base)
      base.extend(ClassMethods)
    end

    def config
      self.class.config
    end

    module ClassMethods
      def configure
        yield config
      end

      def config
        @configuration ||= Configuration.new
      end
    end
  end

  class Configuration
    attr_accessor :api_endpoint, :debug, :debug_connection
    attr_accessor :api_key, :secret_key
    attr_accessor :rest_open_timeout, :rest_timeout
    attr_accessor :api_version
    #oauth / jwt tokens
    attr_accessor :client_id, :client_secret
    attr_accessor :audience, :grant_type, :token_url
    #bearer
    attr_accessor :authorization_token

    def initialize
      self.debug = false
      self.rest_timeout = 30
      self.rest_open_timeout = 30
      self.debug_connection = false
      self.api_version = 1
    end

  end

end
